; This program is free software. It comes without any warranty, to
; the extent permitted by applicable law. You can redistribute it
; and/or modify it under the terms of the Do What The Fuck You Want
; To Public License, Version 2, as published by Sam Hocevar. See
; http://sam.zoy.org/wtfpl/COPYING for more details.


;------ SetUpInterrupts --------------------------------------------------------
SetUpInterrupts:
; Sets up the IM 2 interrupt system, but does not enable interrupts.
; Inputs:
;  - None
; Output:
;  - Interrupts set up
; Destroys:
;  - Assume all
	di
	xor	a
	out	(pIntMask), a
	out	(pCrstlTmr1Freq), a
	out	(pCrstlTmr2Freq), a
	out	(pCrstlTmr3Freq), a
	out	(pLnkAstSeEnable), a
	; And kill USB
;	out	(57h), a
;	out	(5Bh), a
;	out	(4Ch), a
;	ld	a, 2
;	out	(54h), a
	; Custom Interrupts
	ld	hl, IvtLocation*256
	ld	de, IvtLocation*256+1
	ld	bc, 256
	ld	a, IvtLocation
	ld	i, a
	ld	a, IsrLocation
	ld	(hl), a
	ldir
	ld	hl, InterruptServiceRoutine
	ld	de, IsrLocation*256+IsrLocation
	ld	bc, 3
	ldir
	; Enable only wanted interrupts
	;ld	a, tmrFreq0 | memMapMode0 | battVoltage0
	xor	a	; Above expression evaulates to 0
	out	(pAsicMiscCfg), a
	ld	a, intTmr2 | intOnKey | intDisableLowPowerMode
	out	(pIntMask), a
	im	2
	ret
InterruptServiceRoutine:
;	.dw	3
	jp	realIsr
;InterruptServiceRoutineEnd:


;------ Interrupt Service Routine ----------------------------------------------
realIsr:
	push	af
	in	a, (pIntId)
	rra
	jp	c, Quit;intHOnKey
	rra
	jp	c, Quit
	rra
	jr	c, intHPapd
	rra
	rra
	jp	c, Quit
;	rra
;	jr	c, intHCrystal
;	rra
;	jr	c, intHHCrystal
	; Wait, there should be no other active interrupt sources.
;	xor	a
;	out	(pIntAck), a
	;call	RebootMicrOS
;intHLink:
;intHCrystal:
;intHApd: ; WTF, didn't we disable this interrupt?
	jp	Quit
intHPapd:
	push	bc
	; ACK the interrupt
	ld	a, intTmr2 ^ 255
	;xor	a
	out	(pIntAck), a
	; General fast timer.  This is useful for timing routines.
	ld	bc, (genFastTimer)
	inc	bc
_:	ld	(genFastTimer), bc
	ld	a, b
	cp	4
	jr	c, +_
	ld	bc, (suspendTimer)
	dec	bc
	ld	(suspendTimer), bc
	ld	bc, 0
	jr	-_	; Saves one byte.
_:	; Check if we're sleepy
	ld	bc, (suspendTimer)
	ld	a, b
	or	c
	jr	nz, +_
	jp	Quit
_:	; Check if it's time to scan the keyboard
	ld	a, (kbdScanTimer)
	dec	a
	ld	(kbdScanTimer), a
	jr	nz, noScan
	ld	a, kbdScanDivisor
	ld	(kbdScanTimer), a
	call	ScanKeyboard
noScan:	pop	bc
	pop	af
	ei
	ret